(*
 * Copyright (C) 2013, National ICT Australia Limited. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 *  * The name of National ICT Australia Limited nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *)

theory Str2Long
imports
  "../../../c-parser/CTranslation"
  "../../ValidNoFail"
  "../../AutoCorres"
begin

install_C_file "str2long.c"
autocorres "str2long.c"

context str2long begin

(* p is a pointer to a string in s that terminates at p+x *)
definition
  valid_string :: "new_globals \<Rightarrow> word8 ptr \<Rightarrow> word32 \<Rightarrow> bool"
where
  "valid_string s p x \<equiv> heap_w8 s (p +\<^isub>p uint x) = Some 0 \<and> p \<le> p +\<^isub>p uint x"

(* When passed a finite string, str2long never fails *)
lemma "\<lbrace> \<lambda>s. valid_string s str n \<rbrace>
        str2long' str
      \<lbrace>\<lambda>_ _. True\<rbrace>!"
  unfolding str2long'_def
  apply (wp)
  (* Need whileLoopE_add_inv and friends *)
  oops

end
end
